/*$Id: u_parameter.cc,v 25.60 2005/11/30 05:52:21 al Exp $ -*- C++ -*-
 * Copyright (C) 2005 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *------------------------------------------------------------------
 * A class for parameterized values
 * Used for spice compatible .param statements
 * and passing arguments to models and subcircuits
 */
//testing=nonstrict
#include "io_.h"
#include "u_parameter.h"
/*--------------------------------------------------------------------------*/
void PARAM_LIST::parse(CS& cmd)
{
  int here = cmd.cursor();
  do {
    std::string name;
    PARAMETER<double> value;
    cmd >> name >> value;
    _pl[name] = value;      
  }while (cmd.more() && !cmd.stuck(&here));
  cmd.check(bWARNING, "what's this?");
}
/*--------------------------------------------------------------------------*/
void PARAM_LIST::print(OMSTREAM& o)const
{
  for (const_iterator i = _pl.begin(); i != _pl.end(); ++i) {
    o << i->first << " = " << i->second << '\n';
  }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
bool get(CS& cmd, const std::string& key, PARAMETER<bool>* val)
{
  {if (cmd.dmatch(key)) {
    cmd >> *val;
    return true;
  }else if (cmd.dmatch("NO" + key)) {
    *val = false;
    untested();
    return true;
  }else{
    return false;
  }}
}
/*--------------------------------------------------------------------------*/
bool get(CS& cmd, const std::string& key, PARAMETER<int>* val)
{
  {if (cmd.dmatch(key)) {
    *val = int(cmd.ctof());
    return true;
  }else{
    return false;
  }}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
